/*
 * FILE     : McCreght1.h
 * Copyright (C) 2007 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : q[vT McCreght (Place Holderŋp)
 * AUTHER   : N.Tsuchiya  2007.11.25
 */
/*
	q[vT(balanced priority search trees)
	l̕tT؁Al̃q[v
	E.M.McCreight. Priority search trees. SIAM Journal on Computing, 14(2):257.276, May 1985.
 */
#if ! defined(MCCREIGHT1_H)
#define MCCREIGHT1_H

#include "ssc.h"

#if ! defined (VECTOR)
#if 0 //1:<vector>g 0:"sscvect.h"g
#   include <vector>
#   define VECTOR vector
    using namespace std;
#else
#   include "sscvect.h"
#   define VECTOR sscvect
#endif
#endif //! defined (VECTOR)

//#include "sscvect.h"
#include "pstree_memo.h"
#define Empty  0

struct PSTree {  //class
	struct ExtractedPair {
		int 	q;
		bool	duplAsP;
	} ;
	struct BPSTpair {
		int		n;           //ߓ_ԍ([Uw)
		int		x;           //T؂\
		int		y;           //q[v\
		int		emptyNext;   //󃊃NB擪topEmptyPairB-1:gp
//		int dummy;
		bool operator==(const BPSTpair &p) { return n == p.n && x == p.x && y == p.y; }
	//	bool operator==(const BPSTpair &p) { return n == p.n ; }
		BPSTpair():n(-1),x(0),y(0),emptyNext(-1){}                 //ftHgRXgN^
		BPSTpair(const BPSTpair &X):n(X.n),x(X.x),y(X.y),emptyNext(X.emptyNext){} //Rs[RXgN^
		BPSTpair(int pn,int px,int py):n(pn),x(px),y(py),emptyNext(-1){}  //RXgN^ change emptyNext(0)==>(-1) NT120409
		BPSTpair& operator=(const BPSTpair &p) { if( this != &p ) { //Zq
			n = p.n; x = p.x; y = p.y; emptyNext = p.emptyNext;} return *this; }
	} ;
	struct BPSTnode {
		int 	p;       //q[v\B(leaf node)(McCreght validP=.F.)̏ꍇ     pair[]or0
		int 	q;       //T؂\                                     pair[]
		int		oya;     // -2:폜   node[]
		int		left;    // ̋          node[] 
		int		right;   // -2:폜   node[]
//		int    balance;           //(gp) oXx L: ɌXĂB R: EɌXĂBE: EB
		short    hight;             // ؂̍B[̍PDmFpA߂
		bool 	validP;  //(McCreght only) T:t.p͗L(łȂ)
		bool	duplQ;   //(McCreght only) T:t.q͑c悁a.pɐݒς F:t.qƓyA͏ʂ̂ɂ݂͑Ȃ
		BPSTnode():                       //RXgN^
			p(Empty),q(Empty),left(Empty),right(Empty),oya(Empty),validP(0),duplQ(false),hight(0){}
		BPSTnode(const BPSTnode &X):      //Rs[RXgN^
			p(X.p),q(X.q),left(X.left),right(X.right),oya(X.oya),validP(X.validP),duplQ(X.duplQ),hight(X.hight){}
		BPSTnode& operator=(const BPSTnode &pp) { if( this != &pp ) { //Zq
			p = pp.p; q = pp.q; validP = pp.validP; duplQ = pp.duplQ;
			oya = pp.oya; left = pp.left; right = pp.right; hight = pp.hight;} return *this; }
	} ;
	struct PstPairs {              //pair[0]͎gȂ
		VECTOR<BPSTpair> a;        //敪؂̐ߓ_̔zBa[0]͎gȂ
		int num;                   //󂫂ߓ_
	  private:
		int topEmpty;              // pair[]
		VECTOR<int> stack;         //clear(int)Ŏgp
	  public:
		PstPairs() : num(0), topEmpty(0){ a.push_back(BPSTpair()); }   //RXgN^
		~PstPairs(){}              //fXgN^
		int ins(BPSTpair &wkPair);
		int del(int idx);
		BPSTpair& get(int idx);
		PstPairs& operator=(const PstPairs &pp) { if( this != &pp ) { //Zq
			num = pp.num; topEmpty = pp.topEmpty; a = pp.a;} return *this; }
		int clear(int root);
		int clear(){ num = 0; topEmpty = 0; a.clear(); a.push_back(BPSTpair()); return 0; }
	  private:
	} ;
	struct PstNodes {              //ߓ_̏WBnode[0]͎gȂ
		VECTOR<BPSTnode> a;        //敪؂̐ߓ_̔zBa[0]͎gȂ
		int num;                   //󂫂ߓ_
	  private:
		int topEmpty;              // node[]
		VECTOR<int> stack;         //clear(int)Ŏgp
	  public:
		PstNodes() : num(0), topEmpty(0){
			a.push_back(BPSTnode()); }   //RXgN^
		~PstNodes(){}              //fXgN^
		int ins(BPSTnode &wkNode);
		int del(int idx);
		BPSTnode& get(int idx);
		int getTopEmpty() const { return topEmpty; }
		int clear(int root);
		int clear(){ num = 0; topEmpty = 0; a.clear(); a.push_back(BPSTnode()); return 0; }
	  private:
	} ;
	struct NextInf {         //first(), next()p[N
		int node;            //node[]
		int stat;            //0:} 1: 2: 3:E} 4:
		NextInf() : node(0), stat(0) {}
		NextInf(int anode, int st) : node(anode), stat(st) {}
	} ;
static	PstPairs	pairs;        //pair[0]͎gȂ
static	PstNodes	nodes;        //ߓ_̏WBnode[0]͎gȂ
//	VECTOR<BPSTnode> node;    //node[0]͎gȂ
//	VECTOR<BPSTpair> pair;    //pair[0]͎gȂ
	VECTOR<NextInf> nextInf;  //[0]̓X^bN{gŏɂOBfirst(),next()Ŏgp
	int		heapType;         //0:傫D 1:D add NT110404
	int		root;             //                                        node[]
//	int		topPair;          //buildɓn̂ɎgpBnextBPSTpair::emptyNextŕ̒lŎgB
	int		n_pair;
	int		n_node;
	//first() next()Tp
	int		last_node;        //ŌɕԂm[hԍB-1:TI            node[]or-1
	int		lastIsP;          //(McCreght only) 
	int x1, x2, y0;
//	VECTOR<int> ans;    //::firstans(),nextans()̃[NBNT120521add
//	VECTOR<int> stack;  //::firstans(),nextans()̃[NBNT120521add
	~PSTree(){}
	PSTree():heapType(0), root(0), n_pair(0), n_node(0) {}    //RXgN^
	PSTree(const PSTree &X):       //Rs[RXgN^
		//pairs(X.pairs), //nodes(X.nodes),
		heapType(X.heapType), root(X.root) {}  //Rs[RXgN^
	PSTree& operator=(const PSTree &X);       //ZqBvector<PSTree>ɕKv
	int find  (int pn,int px,int py);   //0:݂ >0: NT110903add 
	int insert(int pn,int px,int py);
	int deletion(int pn,int px,int py){int hi; return deletion(&root, BPSTpair(pn, px, py), &hi, 0);}
	void dump_node(int s, int e);
	int side3Query(int x1, int x2, int y0, VECTOR<int>& ans, VECTOR<int>& stack);
	int firstAns(int *inf, int x1, int x2, int y0); //R̍ŏ̓Ԃ
	int nextAns(int *inf);              //R̎̓Ԃ
	int first(int x1, int x2, int y0);  //p~\iϐɋL邽߁j
	int next();                         //p~\iϐɋL邽߁j
	int clear(int heapType = 0);           // add heapType NT110404
//	int size() { return pairs.num; }
	int size() { return n_pair; }
	int	getHheapType(){return heapType;}  //0:傫D 1:D add NT110404
	int getNumOfNode() {return n_node; } //this->nodes.num;}
	int getNumOfData() {return this->n_pair;}

	int firstPair(int *inf); //LȑSpair擾
	int nextPair(int *inf); //>=0:ߓ_ԍ([Uw) -1:I
	//t؂ɕKvȊ֐
	int plus     (PSTree &x, VECTOR<int>&, VECTOR<int>&, VECTOR<int>&);
	int intersect(PSTree &x, PSTree &y, VECTOR<int>&, VECTOR<int>&, VECTOR<int>&);
	int minus    (PSTree &x, VECTOR<int>&, VECTOR<int>&, VECTOR<int>&);
//	sscvect<int> list2;  //::plus̃[NɕKvBNT110824add
	//`FbNp
	void check0(void);
//	int getNList(int *pIdxList,int x_pIdxL,int *n_pIdxL);
	int getNList(VECTOR<int>*);
	//ob`łors֐
	int pair_add(BPSTpair &wkPair);
	int build_sorted(int nList, int *list);
	int build(VECTOR<int>&);
protected:
	int compIdx(const int *p,const int *q ) { return compX( &pairs.a[*p], &pairs.a[*q] );}
private:
	int clear1();           // pair[]ȊONA
	int isLeaf( int anode );   //(Place holder only)
	int disposeP( int anode );
	int extractP( int anode );
	int rotateRight(int *anode, int *phi );
	int rotateLeft (int *anode, int *phi );
	int adjustBalance(int *anode, int *phi);
	int insert(int oya, int lrflg, int np,bool useAsP, int *phi, int findmode);
	int extractMaxQX(int *anode,ExtractedPair *ep, int *pd );      // McCreght1Őp
	int deletion( int *anode, BPSTpair &op, int *phi, int qnode ); //qnode (Place holder only)
	int pair_del( int d );
	int node_add(BPSTnode &wkNode);
	int node_del( int d );
	int compHeap(int p, int q){  //ۓTL[̔rB:(p)D :E(q)D
		if( heapType == 0 ) return QSORT_COMP(q, p);  //傫D add heapType NT110404
		else                return QSORT_COMP(p, q);  //D
	}
	int judgeBalance(int anode);
	int findBelow( int rt );
	int ReportInPSTree(int anode, int y0, VECTOR<int>& ans, VECTOR<int>& stack);
	int build_sub(int *list, int s, int e);
	int getQList(VECTOR<int> *L1, int anode);  //NT120416 privateɖ߂
	int compX( BPSTpair *p, BPSTpair *q )
{
	if     ( p->x < q->x ) return -1;
	else if( p->x > q->x ) return 1;
	return (p->n - q->n);
}
	//`FbNp
	int check1(int oya, int v, BPSTpair &low, BPSTpair &upp);
	int check2_1( int v, VECTOR<int>& vintwk);
	int check2_2( int v, VECTOR<int>& vintwk);
//	sscvect<int> list1;  //
} ;

#endif //! defined(MCCREIGHT1_H)

//#define PSTree_Main
#if defined(PSTree_Main)

PSTree::PstNodes PSTree::nodes;  //static oϐ̎Ԃ`BPstNodes̃RXgN^Ă΂B
PSTree::PstPairs PSTree::pairs;  //static oϐ̎Ԃ`B

/*  ID_PSTree::operator=	ZqBvector<PSTree>ɕKv
***************************************************************************/
PSTree&  PSTree::operator=(const PSTree &X)         //
{
	if( this != &X ) {
//		this->pairs  = X.pairs; 
//		this->nodes  = X.nodes; 
		this->heapType     = X.heapType;    
		this->root         = X.root;
//		this->topPair      = X.topPair;      
		this->n_node       = X.n_node;      
		this->n_pair       = X.n_pair;      
//		this->topEmptyNode = X.topEmptyNode;
//		this->topEmptyPair = X.topEmptyPair;
		this->lastIsP      = X.lastIsP;
	}
	return *this;
}
///*  ID_PSTree::compX	ۓTL[̔rB
//***************************************************************************/
//int PSTree::compX(         //
//	register BPSTpair *p,
//	register BPSTpair *q )
//{
//	register int	rc;
//	if     ( p->x < q->x ) rc = -1;
//	else if( p->x > q->x ) rc = 1;
//	else if( p->n < q->n ) rc = -1;
//	else if( p->n > q->n ) rc = 1;
//	else rc = 0;
//	return rc;
//}
#define PAIR_FIX
/*  ID_PSTree::PstPairs::ins	VKpair[]ɒǉ
***************************************************************************/
int PSTree::PstPairs::ins(BPSTpair &wkPair) //R >0:pair[] 
{
#if defined(PAIR_FIX)
	int d;
	BPSTpair dmPair;
	dmPair.emptyNext = 0;
	d = wkPair.n + 1;                   CHKB(0, 0, wkPair.n);
	while( this->a.size() <= d ) {
		this->a.push_back(dmPair);
	}
	if( this->a.v[d].n >= 0 ) {
		CHKB(wkPair.x, this->a.v[d].x, wkPair.x);
		CHKB(wkPair.y, this->a.v[d].y, wkPair.y);
	}
	this->a.v[d] = wkPair;
	++num;
	return d;
#else
	int d;    CHKB(0, 0, wkPair.n);
	if( isEmpty(topEmpty) ) {
		d = this->a.push_back(wkPair); CHKB(wkPair.emptyNext, -1, -1);
	} else {
		d = topEmpty;
		topEmpty = this->a.v[d].emptyNext;
		this->a.v[d] = wkPair;
		this->a.v[d].emptyNext = -1;    //󃊃NB擪topEmptyB-1:gp
	}
	++num;
	return d;
#endif
}
/*  ID_PSTree::pair_add	VKpair[]ɒǉ
***************************************************************************/
int PSTree::pair_add(BPSTpair &wkPair) //R >0:pair[] 
{
	int apair;
	++n_pair;
	apair = pairs.ins(wkPair);
//	pairs.a[apair].emptyNext = - topPair - 1;
	pairs.a[apair].emptyNext = -1;
//	topPair = apair;
	return apair;
}
/*  ID_PSTree::pair_del	󃊃Nɂ
***************************************************************************/
int PSTree::PstPairs::del( int d )
{
#if ! defined(PAIR_FIX)
	if( this->a.v[d].emptyNext == -1 ) {
	this->a.v[d].emptyNext = topEmpty;
	topEmpty = d;
	} else CHKB(-1, this->a.v[d].emptyNext, -1);  //󃊃NB擪topEmptyPairB-1:gp
#endif
	--num;                              CHKB(0, 0, num);
	return 0;
}
/*  ID_PSTree::pair_del	󃊃Nɂ
***************************************************************************/
int PSTree::pair_del( int d )
{
	--n_pair;                           CHKB(0, 0, n_pair);
	return pairs.del(d);
}
/*  ID_PSTree::PstNodes::ins	VKnode[]ɒǉ
***************************************************************************/
int PSTree::PstNodes::ins(BPSTnode &wkNode)
{
	int d;
	if( isEmpty(topEmpty) ) {
		d = this->a.push_back(wkNode);
	} else {
		d = topEmpty;
		topEmpty = this->a.v[d].left;
		this->a.v[d] = wkNode;
	}
	++num;
	return d;
}
/*  ID_PSTree::node_add	VKnode[]ɒǉ
***************************************************************************/
int PSTree::node_add(BPSTnode &wkNode)
{
	++n_node;
	return nodes.ins(wkNode);
}
/*  ID_PSTree::PstNodes::del	󃊃Nɂ
***************************************************************************/
int PSTree::PstNodes::del( int d )
{	                   CHKA(1, d, this->a.size()); CHKA(0, this->a.v[d].oya, this->a.size());
	this->a.v[d].oya = this->a.v[d].right = -2;
	this->a.v[d].left = topEmpty;
	topEmpty = d;
	--num;
	return 0;
}
/*  ID_PSTree::node_del	󃊃Nɂ
***************************************************************************/
int PSTree::node_del( int d )
{
	--n_node;                           CHKB(0, 0, n_node);
	return nodes.del(d);
}
/*  ID_PSTree::judgeBalance	oXxB<0:ɌXĂ >0:EɌXĂ
***************************************************************************/
int PSTree::judgeBalance(int anode) // 
{
	                                         CHKA(1, anode, nodes.a.size());
	BPSTnode	*t = &nodes.a.v[anode]; //anode=0̎AOԂ͂
	return nodes.a.v[t->right].hight - nodes.a.v[t->left].hight;
}
/*	ID_PSTree::PstPairs::clear	rtȉpair󂫃Nɓ
/*******************************************************************/
int PSTree::PstPairs::clear(int rt)
{
	int rc, v, vL, vR, n_stack; //profilełQQ

	if( rt > 0 ) {
		n_stack  = 0;
		for( v = rt; ; ) {
			vL = nodes.a[v].left;
			vR = nodes.a[v].right;
			if( nodes.a[v].p > 0 ) this->del( nodes.a[v].p );
			if( vL ) {            // v.left nullłȂ
				if( vR ) {       // v.right nullłȂ
					if( n_stack + 1 >= stack.capacity() ) {
						if( (rc = 2 * stack.capacity()) <= 0 ) rc = 4;
						if( stack.resize(rc) < 0 ) { rc = -1; goto quit; }
					}
					stack[n_stack++] = vR; //v.rightvbV_EB
				}
				v = vL;
			} else if( vR  ) {      //v.right nullłȂ
				v = vR;
			} else { //E̎qߓ_
				if( n_stack-- <= 0 ) break;
				v = stack[n_stack];
			}
		}   //end while
	}
	rc = 0;
quit:
	return rc;
}
/*	ID_PSTree::PstNodes::clear	rtȉ̐ߓ_󂫃Nɓ
/*******************************************************************/
int PSTree::PstNodes::clear(int rt)
{
	int rc, v, vL, vR, n_stack; //profilełQQ

	if( rt > 0 ) {
		n_stack  = 0;
		for( v = rt; ; ) {
			vL = nodes.a[v].left;
			vR = nodes.a[v].right;
			this->del( v );
			if( vL ) {            // v.left nullłȂ
				if( vR ) {       // v.right nullłȂ
					if( n_stack + 1 >= stack.capacity() ) {
						if( (rc = 2 * stack.capacity()) <= 0 ) rc = 4;
						if( stack.resize(rc) < 0 ) { rc = -1; goto quit; }
					}
					stack[n_stack++] = vR; //v.rightvbV_EB
				}
				v = vL;
			} else if( vR  ) {      //v.right nullłȂ
				v = vR;
			} else { //E̎qߓ_
				if( n_stack-- <= 0 ) break;
				v = stack[n_stack];
			}
		}   //end while
	}
	rc = 0;
quit:
	return rc;
}

/*  ID_PSTree::clear1	PStreepair[]ȊOclear
***************************************************************************/
int PSTree::clear1(
	)
{
	this->nodes.clear(root);
	root = Empty;
	n_node = 0;
//	node.push_back(BPSTnode());
	return 0;
}
/*  ID_PSTree::clear	PStreeclear
***************************************************************************/
int PSTree::clear(
	int pHeapType)    //i 0:傫D 1:D add NT110404
{
	this->pairs.clear(root);
	this->clear1();          //PStreepair[]ȊOclear
//	this->topPair = 0;
	n_pair = 0;
//	topEmptyPair = Empty;
//	pairs.a.push_back(BPSTpair());
	this->heapType = pHeapType;
	return 0;
}
/*  ID_PSTree::insert	pstreeɒǉ
***************************************************************************/
int PSTree::insert(int pn,int px,int py)
{
	int hi, rc, d;
	d = pair_add(BPSTpair(pn, px, py));
	rc = insert(Empty, 0, d, true, &hi, 0);
	if( isEmpty(rc) ) pair_del(d); 
	return rc;
}
/*  ID_PSTree::find	pstree猟  //NT110903add
***************************************************************************/
int PSTree::find(int pn,int px,int py) //0:݂ >0:
{
	int hi, rc, d;
	d = pair_add(BPSTpair(pn, px, py));
	rc = insert(Empty, 0, d, true, &hi, 1);
	pair_del(d); 
	return (rc > 0);
}
#endif //defined(PSTree_Main)
