/*
 * FILE     : drtree_1.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : ̈(D-dimension range tree)
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include "drtree.h"

/*  ID_Points::clear	|Cg̏WNA
***************************************************************************/
int DRTPoints::clear()
{
	this->num = 0;
	this->dim = 0;
	this->a.clear();
	this->x.clear();
	this->x.push_back(0);   //x[0]͎gȂ
	return 0;
}
/*  ID_Points::find	|Cgԍnõ|Cgz̓YԂ
***************************************************************************/
int DRTPoints::find(   //r |Cgz̓YB-1:G[
	int no,         //i |CgԍBOȏ
	int *x)         //o |Cg̍Wl
{
	int rc = -1, k, topX;					CHKA(0, no, this->a.size());
	if( no < 0 || no >= this->a.size() ) goto               quit;
	if( this->a[no].usef == 0 ) goto                   quit;  //gp 
	topX = this->a[no].topX;
	for( k  = 0; k < this->dim; ++k ) {
		x[k] = this->x[k + topX];
	}
	rc = 0;
quit:
	return rc;
}
/*  ID_Points::ins	|CgWɒǉ
***************************************************************************/
int DRTPoints::ins(    //r >=0:|Cgz̓YB-1:o^ς -2:G[
	int dim,        //i BPȏ
	int no,         //i |CgԍBOȏ
	int *xi)        //i |Cgdim̍Wl
{
	int rc = -1, k, topX;
	DRTPoint wp;

	if( this->dim == 0 ) this->dim = dim;
	else if( this->dim != dim ) { CHKB(this->dim, dim, this->dim); goto  quit; }
	//zg
	while( no >= this->a.size() ) {
		try{ this->a.push_back(wp); } catch(...){rc = -2; goto          quit;}
	}
	if( this->a[no].usef != 0 ) { rc = -1; CHKB(1, this->a[no].usef, 0); goto quit;} //gp
	++this->num;
//	if( this->a[no].usef == 0 ) { ++this->num; //NT110413 add goto quit
//	} else { CHKB(1, this->a[no].usef, 0); goto                         quit; //gp
//	}
	this->a[no].usef = 1;
	this->a[no].no   = no;         //NT110709add
	if( this->a[no].topX <= 0 ) {  //VKǉ
		this->a[no].topX = this->x.size();
		for( k = 0; k < dim; ++k ) {
			try{ this->x.push_back(xi[k]); } catch(...){rc = -2; goto   quit;}
		}
	} else {     //o^ς݂AgpBx[] XV
		topX = this->a[no].topX;
		for( k = 0; k < dim; ++k ) {
			this->x[k + topX] = xi[k];
		}
	}
	rc = no;
quit:
	return rc;
}
/*  ID_Points::del	|CgW폜
***************************************************************************/
int DRTPoints::del(    //r 0:, -1:G[
	int idx)        //i |Cgz̓YBOȏ
{
	int rc = -1;						
	if( idx < 0 || idx >= this->a.size() ) goto          quit;
	if( this->a[idx].usef != 0 ) --this->num;
	else                                CHKB(1, this->a[idx].usef, 1);
	this->a[idx].usef = 0;
	rc = 0;
quit:
	return rc;
}
/*  ID_Points::get	|Cg擾B
***************************************************************************/
DRTPoint& DRTPoints::get( //r |CgB
	int idx)        //i |Cgz̓YBOȏ
{									CHKA(0, idx, this->a.size());
	return(this->a[idx]);
}

/*  ID_Nodes::clear	ߓ_̏WNA
***************************************************************************/
int DRTNodes::clear()
{
	this->num = 0;
	this->emptyTop = 0;
	this->a.clear();
	this->a.push_back(DRTNode());   //node[0]͎gȂ
	return 0;
}
/*  ID_Nodes::ins	ߓ_Wɒǉ
***************************************************************************/
int DRTNodes::ins(    //r >0:ߓ_z̓YB-1:G[
	int oya, int left, int right, int apoint, int aasoc,
	int level)
{
	DRTNode wnod;
	int rc = 0;
										CHKA(0, oya, this->a.size());
	wnod.left  = left;
	wnod.right = right;
	wnod.point = apoint;
	wnod.assocAVL = 0;                 CHKB(0, aasoc, 0);
//v	wnod.level = level;
	if( this->emptyTop > 0 ) {
		rc = this->emptyTop;            CHKB(-1, this->a[rc].left, -1);
		this->emptyTop =  this->a[rc].right;
		this->a[rc] = wnod;
	} else {
		rc = this->a.size();
		this->a.push_back(wnod);
	}
	++this->num;                         CHKB(1, rc, this->a.size());
	return rc;
}
/*  ID_Nodes::setval	ߓ_̓eC
***************************************************************************/
int DRTNodes::setval(
	int anode,
	int oya, int left, int right, int apoint,
	int hight)  //gp
{
	int rc = 0, asize;                  CHKA(1, anode, this->a.size());
	DRTNode &wnod = a[anode];              CHKA(0, wnod.left, this->a.size());
	asize = this->a.size();
					CHKA(0, oya, asize); CHKA(0, left, asize); CHKA(0, right, asize);
	wnod.left  = left;
	wnod.right = right;
	wnod.point = apoint;
//h	wnod.hight = hight;
	return rc;
}
/*  ID_Nodes::del	ߓ_W폜
***************************************************************************/
int DRTNodes::del(
	int idx)        //i ߓ_z̓YBOȏ
{
	int rc = -1;
									    CHKA(1, idx, this->a.size());
	if( idx < 1 || idx >= this->a.size() ) goto                    quit;
	                                    CHKA(0, this->a[idx].left, this->a.size());
	this->a[idx].right = this->emptyTop; CHKA(0, this->emptyTop, this->a.size());
	this->a[idx].left  = -1;
	this->emptyTop = idx;
	--this->num;
	rc = 0;
quit:
	return rc;
}
/*  ID_Nodes::get	ߓ_擾B
***************************************************************************/
DRTNode& DRTNodes::get(   //r ߓ_B
	int idx)        //i ߓ_z̓YBOȏ
{
									CHKA(0, idx, this->a.size());
	return(this->a[idx]);
}


/*  ID_DrTrees::clear	̈؂čėp\ɂ
***************************************************************************/
int DrTrees::clear()
{
	this->psts.clear(); //NT120426
	this->nodes.clear();
	this->points.clear();
	this->mainTree = 0;
	this->dim = 0;
	return 0;
}
/*  ID_DrTrees::point_ins	P̓__WɒǉBcreate()Ăō̈؂ꊇ\
***************************************************************************/
int DrTrees::point_ins(    //rc>0:,|Cgz̓YB=-1:G[
	int dim,        //i BPȏBdimׂ͂ēƁB
	int poNo,       //i |CgԍBOȏBpoNôQd`͕sB
	int *xi)        //i |Cgdim̍Wl
{
	return points.ins(dim, poNo, xi);
}
