/*
 * FILE     : drtree_query.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : ̈(D-dimension range tree)
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include "drtree.h"

/*  ID_DrTrees::compVectLE	levelȏ̎łׂBïTpj
***************************************************************************/
int DrTrees::compVectLE(       //r 1:yes 0:no leveldim̎yesԂ
	int level, int *p,int *q)
{
	for( ; level < dim; ++level ) {
		if( p[level] > q[level] ) break;
	}
	return (level >= dim);
}
/*  ID_DrTrees::compElem	levelԖڂ̗vfrBïTpj
***************************************************************************/
int DrTrees::compElem(       //r 0: <0: >0:
	int level, int *p,int *q)
{
	int rc;
	if( level >= dim - 1 ) { CHKA(0, level, dim); return 0; } //leveldim ͂肦Ȃ
	if     ( p[level] < q[level] ) rc = -1;
	else if( p[level] > q[level] ) rc = 1;
	else                           rc = 0;
	return rc;
//	return ( p[level] - q[level]);
}
/*  ID_DrTrees::FindSplitNode	low[level] <= p[level] <= high[level]̃m[hT
***************************************************************************/
int DrTrees::FindSplitNode(
	int level,
	int root,
	int *low,
	int *high )
{
	int v, *vvect;
	DRTNode *vnode;
	DRTPoint *vpoint;
	for( v = root; v > 0; ) {
		vnode  = &nodes.a[v];
		vpoint = &points.a[vnode->point];
		vvect  = &points.x[vpoint->topX];
		if( compElem(level, low , vvect) > 0 ) {
			v = vnode->right;
		} else if( compElem(level , vvect, high) > 0 ) {
			v = vnode->left;
		} else {
			break;
		}
	}
	return v;
}
/*  ID_DrTrees::D1RangeQuery	anodeȉSans[]ɓo^
***************************************************************************/
int DrTrees::D1RangeQuery(
	int anode)       //i       node[]
{
	DRTNode *vnode;

	if( anode > 0 ) {
		vnode  = &nodes.a[anode];
		D1RangeQuery(vnode->left);
		ans.push_back(vnode->point); //{points.a[]zYłȂApoints.ins()ł|CgԍpushB
		D1RangeQuery(vnode->right);
	}
	return 0;
}
/*  ID_DrTrees::leafTest	tm[h̃|Cg㉺ȂansɒǉBtɂ͓؂͍Ȃ
***************************************************************************/
int DrTrees::leafTest( //r anode 1:tm[h 0:ԃm[h
	int level,
	int anode,
	int *low,
	int *high)
{
	int rc;					CHKA(1, anode, nodes.a.size()); //CHKA(0, anode, nodes.a.size());NT120418
	DRTNode *vnode = &nodes.a[anode];
	DRTPoint *vpoint = &points.a[vnode->point];
	rc = (vnode->left <= 0 && vnode->right <= 0);
	if( rc ) {
		int *vvect  = &points.x[vpoint->topX];
		if( compVectLE(level, low , vvect) && compVectLE(level, vvect, high) )
			ans.push_back(vnode->point); //{points.a[]zYłȂApoints.ins()ł|CgԍpushB
	}
	return rc;
}
/*  ID_DrTrees::subQuery	anodeȉSans[]ɓo^
***************************************************************************/
int DrTrees::subQuery(
	int level,      //i  0..dim-1
	int anode,       //i       node[]
	int *low,       //l x, y,...
	int *high)      //l x, y,...
{
	int apoint, x1, x2, yy, inf;

	if( anode > 0 ) {
		//first	x1xx2yy0łŏ̃m[h̐ߓ_ԍ([Uw)Ԃ
		PSTreeAsoc &asoct = psts.ary[nodes.a[anode].asocT];
		x1 = low [level];
		x2 = high[level];
		yy = low [level+1];
		if( asoct.getHheapType() != 0 ) {  //0:傫D 1:D
			yy = high[level+1];
		}
#if 1
		asoct.side3Query(x1, x2, yy, oya1, oya2);
		for( inf = 0; inf < oya1.size(); ++inf ) {
			apoint = oya1[inf];              CHKA(0, apoint, points.a.size());
			ans.push_back(apoint);
		}
#else
		for( apoint = asoct.firstAns(&inf, x1, x2, yy); apoint >= 0; apoint = asoct.nextAns(&inf) ) {
//		for( apoint = asoct.first(x1, x2, yy); apoint >= 0; apoint = asoct.next() ) {
			ans.push_back(apoint);
			//apoint 񍐂ׂǂׂifobOpj
			if(dbgf[8]) {
//Ƃ		if( points.a[apoint].isCross(lrOpen, points.a[apoint], q) ) {
//L		} else { //ɂ͗Ȃ͂
//					apoint = apoint; CHKA(0, apoint, -571);
//				}
			}
		}
#endif
	}
	return 0;
}
/*  ID_DrTrees::nextLevelRangeQuery	̃xT
***************************************************************************/
int DrTrees::nextLevelRangeQuery(
	int level,      //i  0..dim-1 anodẽx
	int anode,      //i
	int *low,       //i l x, y,...
	int *high)      //i l x, y,...
{
	if( anode > 0 ) {
		if( leafTest(level + 1, anode, low, high) == 0 ) { //ԃm[h
			if( level + 1 >= dim - 1 ) { CHKA(level, dim, -571); //DRPSTreeł͗Ȃ
				D1RangeQuery(anode);
			} else if( level + 2 >= dim - 1 ) {
				subQuery( level + 1, anode, low, high);
			} else {
				DRangeQuery(level+1, nodes.a[anode].assocAVL, low, high);
			}
		}
	}
	return 0;
}
/*  ID_DrTrees::DRangeQuery	low <= p <= high̃m[hԍ̃Xgans[]ɍ
***************************************************************************/
int DrTrees::DRangeQuery(
	int level,      //i  0..dim-1
	int root,       //i       node[]
	int *low,       //i l x, y,...
	int *high)      //i l x, y,...
{
	int vsplit, v, *vvect;
	DRTNode *vnode;
	DRTPoint *vpoint;

	if( level >= dim - 1 ) goto                                           quit;
	if( nodes.num <= 0 ) {              CHKB(0, root, 0);
	} else                              CHKA(1, root, nodes.a.size());
	// vsplit  FindSplitNode(T , x, x)
	vsplit = FindSplitNode(level, root, low, high ); CHKA(0, vsplit, nodes.a.size());
	//vsplitnull then Ȃ
	if( vsplit <= 0 ) {
	} else {
		//vsplit 񍐂ׂǂׂ
		vnode  = &nodes.a[vsplit];
		vpoint = &points.a[vnode->point];
		vvect  = &points.x[vpoint->topX];
		if( compVectLE(level+1, low , vvect) && compVectLE(level+1, vvect, high) ) {
			ans.push_back(vnode->point); //{points.a[]zYłȂApoints.ins()ł|CgԍpushB
		}
		//x ւ̌oHɉC̉E̕؂̃f[^
		//v  lc(vsplit)
		v = vnode->left;
		//while v nullłȂ do
		while( v > 0 ) {
			vnode  = &nodes.a[v];
			vpoint = &points.a[vnode->point]; 
			vvect  = &points.x[vpoint->topX];
			//if x <= x(v) then
			if( compElem(level, low , vvect) <= 0 ) {
				//v 񍐂ׂǂׂ
				if( compVectLE(level+1, low , vvect) && compVectLE(level+1, vvect, high) ) {
					ans.push_back(vnode->point); //{points.a[]zYłȂApoints.ins()ł|CgԍpushB
				}
				//1DRangeQuery(Tassoc(rc(v)), [y : y])
				nextLevelRangeQuery(level, vnode->right, low, high);
				//v  lc(v)
				v = vnode->left;
			} else {
				//v  rc(v)
				v = vnode->right;
			}
		}
		//x ւ̌oHɉC̍̕؂̃f[^
		vnode  = &nodes.a[vsplit];
		v = vnode->right;
		while( v > 0 ) {
			vnode  = &nodes.a[v];
			vpoint = &points.a[vnode->point];
			vvect  = &points.x[vpoint->topX];
			//if x(v) <= x' then
			if( compElem(level , vvect, high) <= 0 ) {
				//v 񍐂ׂǂׂ
				if( compVectLE(level+1, low , vvect) && compVectLE(level+1, vvect, high) ) {
					ans.push_back(vnode->point); //{points.a[]zYłȂApoints.ins()ł|CgԍpushB
				}
				//1DRangeQuery(Tassoc(lc(v)), [y : y])
				nextLevelRangeQuery(level, vnode->left, low, high);
				//v  rc(v)
				v = vnode->right;
			} else {
				//v  lc(v)
				v = vnode->left;
			}
		}
	}
quit:
	return ans.size();
}
/*  ID_DrTrees::getnum	low <= p <= high̃|CgԂ
***************************************************************************/
int DrTrees::getnum(
	int *low,
	int *high)
{
	ans.clear();
	//low <= p <= high̃m[h̃Xg
	DRangeQuery(0, mainTree, low, high);
	if(dbgf[8]) check_ans(low, high);  //query̓̃`FbN
	return ans.size();
}
/*  ID_DrTrees::getinf	Ԗڂ̓_̔ԍԂ
***************************************************************************/
int DrTrees::getinf(
	int k)
{					CHKA(0, k, ans.size());
	int rc;
	if( k < 0 || k >= ans.size() ) rc = -1;
	else {			CHKA(0, ans[k], points.a.size());
		rc =  ans[k];
	}
	return rc;
	//return (k < 0 || k >= ans.size()) ? -1 : ans[k];
}
/*  ID_DrTrees::getNodeNum	nodes.numԂBPSTm[hݒ
***************************************************************************/
int DrTrees::getNodeNum(
	int *pstNodeNum, int *pstPairNum)
{
	int rc, k;

	*pstNodeNum = *pstPairNum = 0;
	for( k = 1; k < psts.n_ary; ++k ) {
		if( psts.ary[k].emptyNext >= 0 ) continue;
		if( psts.ary[k].n_node == 0 )	continue;
//		*pstNodeNum += psts.ary[k].nodes.num;
		*pstNodeNum += psts.ary[k].n_node;
		*pstPairNum += psts.ary[k].n_pair;
	}
	rc = nodes.num;
if( dbgf[0] ) Dprintf("n_ary(%d)rc(%d)pstNodeNum(%d)emptyNext(%d)\n", psts.n_ary, rc, *pstNodeNum, *pstPairNum);
	return rc;
}
