/*
 * SYSTEM	: nVXeWCu
 * FILE 	: rbtree2.cpp
 * All Rights Reserved, Copyright(C) 2011, Sogen System Co., Ltd.
 * FUNCTION : ԍ read black tree
	yI敪؁zDynamic Segment Trees for Ranges and Prefixes
	Yeim-Kuan Chang and Yung-Chieh Lin, IEEE Trans. on computers, Vol56, No 6, June 2007
 * AUTHER	: N.Tsuchiya  2011.05.18
 */
/*http://researchmap.jp/mushftcz4-1587/?block_id=1587&active_action=multidatabase_view_main_detail&multidatabase_id=165&content_id=791*/
//茓 MF 
//#define RED_BLACK_TREE_TEST 

#if defined RED_BLACK_TREE_TEST
#  define EXTERN
#endif
#include <stdio.h>
#include <stdlib.h>
#include "ssc.h"

static char	*__file =(char*)__FILE__;	/* should be copied into all .c files	 */
#define		E_AVLFIND	-1  /* tȂ */
#define		E_AVLDOUBLE	-2  /* l͓Ȃ */
#define		E_AVLALLOC	-4  /* ̈mۂɎs */
#define		E_AVLOPEN	-5  /* r֐o^BI[vĂȂ */

//#include "rbtree.h"
#include "segtree.h"
#include "rbtree_memo.h"
//===============>  rbtree.hɃRs[
/*
 * SYSTEM	: nVXeWCu
 * FILE 	: rbtree.h
 * All Rights Reserved, Copyright(C) 2011, Sogen System Co., Ltd.
 * FUNCTION : ԍ read black tree
 * AUTHER	: N.Tsuchiya  2011.05.18
 */
#define RBTREE_H
#if ! defined RBTREE_H
#define RBTREE_H

#include <vector>
using namespace std;

class RbTree {
public:
	enum RbtColor { RED, BLACK };
private:
	typedef int RbtData;
	struct RbtNode {
		int	parent;     // em[hzԍBċAorX^bNgΏȗB     node[]or 0
		int	left;       // q -1:                                         node[]or 0or-1
		int	right;      // Eq 󂫃Nnextɗp 擪.topempty          node[]or 0
		RbtData key;    // L[
		RbtColor color; // F
	public:
		RbtNode():color(BLACK), key(0), parent(0), left(0), right(0) {}
	} ;
	vector<RbtNode> node; //m[h̔z [0]͎gȂ
	int	topempty;   // 폜m[hN̐擪                                   node[]or 0
//	int findNode;   // this->find()Ōꂽm[hBp~               node[]or 0
	int (*compare)(int,int); // r֐ <0: >0:E 0:
	int root;       // ߓ_                                                   node[]or 0
	const int nil;  // NILߓ_ (ԕ)
	int num;        // i[ꂽm[h
	int numMax;     // i[ꂽm[hnum̍ől
public:
	RbTree():topempty(0), nil(0), root(0), num(0), numMax(0), compare(0) {node.push_back(RbtNode());}
	~RbTree() {}
	// ؂̃f[^āAėp\ɂB
	int clear(      //R ɂOԂ
		int (*compare)(int,int));	//i r֐
	// ؂Ƀm[hǉBQdo^B
	int add(        //R 0: -2: -4:̈mۂɎs -5:r֐o^ <0:G[
		int val);   //i L[ƂȂlBz̓YȂǁB
	// ؂m[hP폜B
	int del(        //R 0: -1:݂Ȃ -5:r֐o^  <0:G[
		int val);   //i L[ƂȂlBz̓YȂǁB
	// ؂Ãm[ḧʒuɕۑB
	int find(       //R >=0:݂ -1:݂Ȃ -5:r֐o^  <0:G[
		int *inf ,  //o 
		int val);	//i L[ƂȂlBz̓YȂǁB
	// ؂̍ŏ^ő̃m[h̒lԂÃm[ḧʒuɕۑB
	int first(      //R >=0:擾vall -1:݂Ȃ -5:r֐o^  <0:G[
		int *inf ,  //o 
		int mode);  //i o̒`(1:ŏ̃m[h珬 -1:ő̃m[h傫)
	// ؂玟̒lԂB̒ĺ|PԂB
	int next(       //R >=0:擾vall -1:݂Ȃ -5:r֐o^  <0:G[
		int *inf ,  //io 
		int mode);  //i o̒`(1:ɑ傫m[h -1:ɏm[h)
	// ؂̃`FbNBoXA召֌WAm[h
	int	check(){int chk_sav = chk_; rb_check(root); return chk_ - chk_sav;}
	// ؂̃_v
	void dump(){print_tree(root, 0);}
	// ؂̃m[h
	int getNnum(){return( this->num );}
	// ؂ŏ
	int memory( //ɂOԂ
		int *recl,	//o 1RbtNodẽoCgTCY
		int *rsvd,	//o mۂm[h̍v
		int *used)	//o gpς݃m[h̍v
		{*recl = sizeof(RbtNode); *rsvd = node.capacity(); *used = numMax; return 0;}
private:
	int rbtree_minimum(int x);   
	int rbtree_successor(int x); 
	int rb_search(RbtData k);    
	void left_rotate(int x);     
	void right_rotate(int x);    
	void rb_insert_fixup(int x); 
	int  rb_insert(RbtData k, int *fndfg);
	void rb_delete_fixup(int x); 
	int rb_delete(RbtData k);    
	int allocate_node(int oya,RbtData k);
	void free_node(int x);       
	void print_tree(int x, int lv);
	int rb_check(int x);
} ;
#endif //! defined RBTREE_H
//<=============== ܂ rbtree.hɃRs[
#define RbTree SegTree
#define RbtNode SegNode

#define Root(T)   ((this)->root)   //(T->root)
#define Key(x)    (nodes.a[x].key)    //(x->key)
#define Left(x)   (nodes.a[x].left)   //(x->left)
#define Right(x)  (nodes.a[x].right)  //(x->right)
#define Parent(x) (nodes.a[x].oya) //(x->parent)
#define Color(x)  (nodes.a[x].color)  //(x->color)
#define NodeSize  nodes.a.size
//#define Nil(T)    ((this)->nil)    //(T->nil)
#define NilParent(T)    ((this)->nil)    //(T->nil)
#define LeafNode(x)    (nodes.a[x].left == 0 || nodes.a[x].right == 0)    //敪؂̗tm[h
#define isNilNode(x) ((x)==(this)->nil)
#define NilNode(x) ((this)->nil)    //Ƃō
#define Minv(x)    (nodes.a[x].minv)
#define Maxv(x)    (nodes.a[x].maxv)
#define AsocT(x)    (nodes.a[x].asocT)
#define Usecnt(x)   (nodes.a[x].usecnt)
/*	ID_dfltcomp	ftHg̔r֐
*******************************************************************/
//static int dfltcomp( int p, int q ) { return( p - q ); }
static int dfltcomp( int p, int q ) { return QSORT_COMP(p, q); }
#if 0
/*	ID_clear	؂̃f[^āAėp\ɂB
*******************************************************************/
int RbTree::clear( //R ɂOԂ
	int (*compfunc)(int,int))	//i r֐
{
	int 	rc = 0;

	if( compfunc )           this->compare = compfunc;  /* [Uw̔r֐ */
	if( this->compare == 0 ) this->compare = dfltcomp; /* ftHg̔r֐ */
	this->topempty = this->root = 0; //this->findNode = 
	this->node.clear();
	this->node.push_back(RbtNode()); //node[0]쐬ĂB
	this->num = 0;              /* i[ꂽm[h   */
	return( rc );
}
#endif
/*	ID_add	؂Ƀm[hǉBQdo^͕sB
*******************************************************************/
int RbTree::add( //R 0: -2: -4:̈mۂɎs <0:G[
	int val)     //i L[ƂȂlBz̓YȂǁB(-1:this->next()Ŏ̒l -4:r֐o^)
{
	int 	rc, fndfg;

	if( this->compare == NULL ) { rc = E_AVLOPEN; goto                  quit; }
    if( (rc = this->rb_insert(val, &fndfg)) < 0 ) goto                  quit;
	if( fndfg != 0 ) { rc = E_AVLDOUBLE; goto                           quit; }
//	this->findNode = 0;
	rc = 0;
	if(dbgf[8]) rb_check(root);
quit:
	return(rc);
}
/*	ID_del	؂m[hP폜B
*******************************************************************/
int RbTree::del( //R 0: -1:݂Ȃ  <0:G[
	int val)     //i L[ƂȂlBz̓YȂǁB(-1:this->next()Ŏ̒l -4:r֐o^)
{
	int rc, z;

	if( this->compare == NULL ) { rc = E_AVLOPEN; goto                  quit; }
    z = this->rb_search(val);
	if( z == nil ) { rc = E_AVLFIND; goto                             quit; }
	--Usecnt(z);
	if( Usecnt(z) <= 0 ) {
		rb_delete(z);
	}
//	this->findNode = 0;
//	this->num -= 1;
	rc = 0;
	if(dbgf[8]) rb_check(root);
quit:
	return(rc);
}
/*	ID_find	؂Ãm[ḧʒuɕۑB
*******************************************************************/
int RbTree::find( //R >=0:݂ -1:݂Ȃ  <0:G[
	int *inf ,     //o 
	int val)      //i L[ƂȂlBz̓YȂǁB(-1:this->next()Ŏ̒l -4:r֐o^)
{
	int 	rc, anp;

	if( this->compare == NULL ) { rc = E_AVLOPEN; goto     quit; }
	anp = rb_search(val);
//	this->findNode = anp;               CHKA(0, anp, NodeSize());
	*inf = anp;
//	rc = (anp > 0 ? node[anp].key : E_AVLFIND);
	rc = (anp > 0 ? Key(anp) : E_AVLFIND);
quit:
	return(rc);
}
/*	ID_first	؂̍ŏ^ő̃m[h̒lԂÃm[ḧʒuɕۑB
*******************************************************************/
int RbTree::first( //R >=0:݂ -1:݂Ȃ  <0:G[
	int *inf ,     //o 
	int mode)      //i o̒`(1:ŏ̃m[h珬 -1:ő̃m[h傫)
{
	int 	rc, anp;

	if( this->compare == NULL ) { rc = E_AVLOPEN; goto     quit; }
	if( (anp = this->root) <= 0 ) {
	} else if( mode > 0 ) {         /* 1:ŏ̃m[h */
//		while( node[anp].left > 0 ) anp = node[anp].left;
		while( Left(anp) > 0 ) anp = Left(anp);
	} else {                        /* -1:ő̃m[h */
//		while( node[anp].right > 0 ) anp = node[anp].right;
		while( Right(anp) > 0 ) anp = Right(anp);
	}
//	this->findNode = anp;
	*inf = anp;
//	rc = (anp > 0 ? node[anp].key : E_AVLFIND);
	rc = (anp > 0 ? Key(anp) : E_AVLFIND);
quit:
	return(rc);
}
/*	ID_next	؂玟̒lԂB̒ĺ|PԂB
*******************************************************************/
int RbTree::next(  //R >=0:݂ -1:݂Ȃ  <0:G[
	int *inf ,     //io 
	int mode)      //i o̒`(1:ŏ̃m[h珬 -1:ő̃m[h傫)
{
	int 	anp, nko, rc = -1;
	                                    CHKB(-1,mode,1);
	if( this->compare == NULL ) { rc = E_AVLOPEN; goto         quit; }
//	if( (anp = this->findNode) <= 0 ) {
	if( (anp = *inf) <= 0 ) {
	} else if( mode > 0 ) { 	/* 1:̑傫m[h */
		anp = rbtree_successor(anp);
	} else {                 	/* -1:̏m[h */
//		if( node[anp].left <= 0 ) {
		if( Left(anp) <= 0 ) {
//			for( nko = anp; (anp = node[anp].parent) > 0; nko = anp )
			for( nko = anp; (anp = Parent(anp)) > 0; nko = anp )
//				if( nko == node[anp].right ) break;
				if( nko == Right(anp) ) break;
		} else {
//			for( anp = node[anp].left; ; anp = node[anp].right )
			for( anp = Left(anp); ; anp = Right(anp) )
//				if( node[anp].right <= 0 ) break;
				if( Right(anp) <= 0 ) break;
		}
	}
//	this->findNode = anp;
	*inf = anp;
//	rc = (anp > 0 ? node[anp].key : E_AVLFIND);
	rc = (anp > 0 ? Key(anp) : E_AVLFIND);
quit:
	return(rc);
}

#define AssocTree(a) (psts.ary[AsocT(a)])
/*	ID_rb_rotate_fixup	]̐WCBI敪
*******************************************************************/
/*gp*/ int RbTree::check_rotate_fixup(  //gp R 0:  <0:G[
	int x,      //i 
	int y)      //i 
{
CHKA(0, 0, -571);
	int apair, apoi, x1, x2, minv, maxv;
	PSTreeAsoc &pst = AssocTree(x);
	minv = Minv(y);
	maxv = Maxv(y);
//int atode_henkou;
//	pst.getQList(&xsortwk, pst.root);
//	for( k = 0; k < xsortwk.size(); ++k ) {
//		apair = xsortwk[k];
	for( apair = 1; apair < pst.pairs.a.size(); ++apair ) {
		if( pst.pairs.a[apair].emptyNext >= 0 ) continue;
		apoi = pst.pairs.a[apair].n;
		x1 = points.a[apoi].x1;     CHKB(x1, x1, minv);
		x2 = points.a[apoi].x2;     CHKB(maxv, x2, x2);
	}
	return 0;
}
/*	ID_rb_rotate_fixup	]̐WCBI敪
*******************************************************************/
int RbTree::rb_rotate_fixup(  //R 0:  <0:G[
	int a, int x, int b, int y, int c)      //i 
{
	int rc = 0;                         CHKA(1, a, NodeSize());
//	rc = AssocTree(c).plus(AssocTree(y));
	rc = psts.plus(&AsocT(c), AsocT(y));         //bb{x
//	AssocTree(b).plus(AssocTree(y));
	rc = psts.plus(&AsocT(b), AsocT(y));         //aa{x
//	AssocTree(y).intersect(AssocTree(a), AssocTree(b));
	rc = psts.intersect(&AsocT(y), AsocT(a), AsocT(b)); //x`a
//	AssocTree(a).minus(AssocTree(y));
	rc = psts.minus(&AsocT(a), AsocT(y));        //``|x
//	AssocTree(b).minus(AssocTree(y));
	rc = psts.minus(&AsocT(b), AsocT(y));        //aa|x
//	if(dbgf[8]) check_rotate_fixup(psts, b, b);
	//ĂёłAւ
	return rc;
}
//--------------------------------------------------------------------------------------
//http://researchmap.jp/mushftcz4-1587/?block_id=1587&active_action=multidatabase_view_main_detail&multidatabase_id=165&content_id=791
//茓 MF 
int RbTree::rbtree_minimum(
	int x)
{
//	while (Left(x) != Nil(T)) {
	while ( ! LeafNode(Left(x)) ) {
		x = Left(x);
	}
	return x;
}

int RbTree::rbtree_successor(int x)
{
  int y; //RbtNode *y;
//  if (Right(x) != Nil(T)) return rbtree_minimum(Right(x));
  if ( ! LeafNode(Right(x)) ) return rbtree_minimum(Right(x));
  y = Parent(x);
//  while (y != Nil(T) && x == Right(y)) {
  while (! LeafNode(y) && x == Right(y)) {
    x = y;
    y = Parent(y);
  }
  return y;
}
int RbTree::rb_search(RbtData k)
{
  int x, comp; //RbtNode *x;

  x = Root(T);
//  while (x != Nil(T) && k != Key(x)) {
  while (! LeafNode(x) && k != Key(x)) {
	comp = (*this->compare)( k, Key(x) );
    if      (comp < 0) x = Left(x);
    else if (comp > 0) x = Right(x);
	else break;
  }
  if( LeafNode(x) ) x = nil; //[_Ȃ
  return x;
}

void RbTree::left_rotate(
	int x)
{
  int y, w; //RbtNode *y;
  y = Right(x);
  Right(x) = Left(y); // y ̍؂ x ̉E؂ɂ
  if ( ! isNilNode(Right(x)) ) Parent(Right(x)) = x; //̕Ղ NT120409
  else CHKA(0, 0, -571);
  Parent(y) = Parent(x);
//  if (Parent(x) == Nil(T)) {
  if (Parent(x) == NilParent(T) ) {  Root(T) = y;
  } else if (x == Left(Parent(x))) { Left(Parent(x)) = y;
  } else {                           Right(Parent(x)) = y;
  }
  Left(y) = x;
  Parent(x) = y;
  //Ԃ̏C
  Minv(y) = Minv(x);
  Maxv(x) = Key(y);
  //]̐WCBI敪
  rb_rotate_fixup(Left(x), x, Right(x), y, Right(y) );
  w = AsocT(y); AsocT(y) = AsocT(x); AsocT(x) = w;
}

void RbTree::right_rotate(
	int x)
{
  int y, w; //RbtNode *y;
  y = Left(x);
  Left(x) = Right(y);
  if ( ! isNilNode(Left(x)) ) Parent(Left(x)) = x; //̕Ղ NT120409
  else CHKA(0, 0, -571);
  Parent(y) = Parent(x);
//  if (Parent(x) == Nil(T)) {
  if (Parent(x) == NilParent(T)) {     Root(T) = y;
  } else  if (x == Right(Parent(x))) { Right(Parent(x)) = y;
  } else {                             Left(Parent(x)) = y;
  }
  Right(y) = x;
  Parent(x) = y;
  //Ԃ̏C
  Maxv(y) = Maxv(x);
  Minv(x) = Key(y);
  //]̐WCBI敪
//rb_rotate_fixup(psts, Right(y), y,  Left(y), x, Left(x));
//  rb_rotate_fixup(psts, Left(y), y,  Left(x), x, Right(x));
  rb_rotate_fixup(Right(x), x,  Left(x), y, Left(y));
  w = AsocT(y); AsocT(y) = AsocT(x); AsocT(x) = w;
}

void RbTree::rb_insert_fixup(
	int x)
{
  int y, z; //RbtNode *y, *z;
  while (Color(Parent(x)) == RED) { // 2F؏𖞂ĂȂȂC
    z = Parent(x);                  // z  x ̐e
    if (z == Left(Parent(z))) {     // z ̎q̏ꍇ
      y = Right(Parent(z));         // y  z ̌Z
      if (Color(y) == RED) {        // ꍇ1: y Ԃ̂Ƃ
        Color(z) = BLACK;
        Color(y) = BLACK;
        Color(Parent(z)) = RED;
        x = Parent(z);
      } else {
		  if (x == Right(z)) {      // ꍇ2: y  x E̎q̏ꍇ
          x = z;
          left_rotate(x); //
         
        } // ꍇ3 ֑
        Color(Parent(x)) = BLACK;   // ꍇ3: y  x ̎q̏ꍇ
        Color(Parent(Parent(x))) = RED;
        right_rotate(Parent(Parent(x)));
      }
    } else { // z E̎q̏ꍇ
      y = Left(Parent(z));
      if (Color(y) == RED) {
        Color(z) = BLACK;
        Color(y) = BLACK;
        Color(Parent(z)) = RED;
        x = Parent(z);
      } else {
        if (x == Left(z)) {
          x = z;
          right_rotate(x);
        }
        Color(Parent(x)) = BLACK;
        Color(Parent(Parent(x))) = RED;
        left_rotate(Parent(Parent(x)));
      }
    }
  }
  Color(Root(T)) = BLACK;
}

int RbTree::rb_insert(  //R >0:ǉ̎q؂̍m[hԍ -4:̈mۂɎs node[]or-4
	RbtData val,          //i
	int *fndfg)        //o ǉΏۂ𔭌 1: 0:łȂ <0:G[
{
	int x, y, z, comp = 0; //RbtNode *x,*y;
	*fndfg = 0;
//	y = Nil(T);
	y = NilParent(T);
	x = Root(T);
//	while (x != Nil(T)) {// val }ꏊ x ߂
	while ( ! LeafNode(x) ) {// val }ꏊ x ߂
		y = x; // y  x ̐e
		comp = (*this->compare)( val, Key(x) );
		if     ( comp < 0 )  x = Left(x);
		else if( comp > 0 )  x = Right(x);
		else break;    //L[v
	}
//	if( x != Nil(T) ) {    //L[𔭌
	if( ! LeafNode(x) ) {  //L[𔭌B
		*fndfg = 1;        //comp == 0
		++Usecnt(x);
		z = x; goto                                                     quit;
	}
	if( (z = allocate_node(y, x, val, 1)) < 0 ) goto                             quit;
//	++Usecnt(z);
	Parent(z) = y; // z ̐e y ɂ
//	if (y == Nil(T)) {
	if (y == NilParent(T)) { Root(T) = z; // T Ȃ z ߓ_
	} else if ( comp < 0 ) { Left(y) = z; // y ̎q z ɂ
	} else if ( comp > 0 ) { Right(y) = z;
	} else                              CHKA(1, comp, -1);
	Color(z) = RED; // Vߓ_͐Ԃɂ
	rb_insert_fixup(z);
quit:
  return z;
}

void RbTree::rb_delete_fixup(
	int x)
{
  int w; //RbtNode *w;
  while (x != Root(T) && Color(x) == BLACK) {
    if (x == Left(Parent(x))) { // x ̎q̏ꍇ
      w = Right(Parent(x)); // w  x ̌Z
      if (Color(w) == RED) { // ꍇ1: w 
        Color(w) = BLACK;
        Color(Parent(x)) = RED;
        left_rotate(Parent(x));
        w = Right(Parent(x));
      } // ꍇ2 ֑
      if (Color(Left(w)) == BLACK && Color(Right(w)) == BLACK) { // ꍇ2: w ̍E̎q
        Color(w) = RED;
        x = Parent(x); // 1ɈړčēxJԂ
      } else {
        if (Color(Right(w)) == BLACK) { // ꍇ3: w ̉E̎q
          Color(Left(w)) = BLACK;
          Color(w) = RED;
          right_rotate(w);
          w = Right(Parent(x));
        } // ꍇ4 ֑
        Color(w) = Color(Parent(x));  // ꍇ4: w ̉E̎q
        Color(Parent(x)) = BLACK;
        Color(Right(w)) = BLACK;
        left_rotate(Parent(x));
        x = Root(T); // I
      }
    } else {
      w = Left(Parent(x));
      if (Color(w) == RED) {
        Color(w) = BLACK;
        Color(Parent(x)) = RED;
        right_rotate(Parent(x));
        w = Left(Parent(x));
      }
      if (Color(Right(w)) == BLACK && Color(Left(w)) == BLACK) {
        Color(w) = RED;
        x = Parent(x);
      } else {
        if (Color(Left(w)) == BLACK) {
          Color(Right(w)) = BLACK;
          Color(w) = RED;
          left_rotate(w);
          w = Left(Parent(x));
        }
        Color(w) = Color(Parent(x));
        Color(Parent(x)) = BLACK;
        Color(Left(w)) = BLACK;
        right_rotate(Parent(x));
        x = Root(T);
      }
    }
  }
  Color(x) = BLACK;
}
//IEEE Trans. on computers, Vol56, No 6, June 2007 P779 Case3:delete node z of degree 2 Q
int RbTree::case3_degree2(
	int z,          //폜L[m[hBEƂtłȂ
	int y)          //ۂɍ폜m[hB̎ɑ傫L[lm[h
{
	int rc, i, zkey, x, apoint, inf, iy, ix, jy, bpoint;
	PSTreeAsoc *x_pst, *ix_pst, *jy_pst;
	zkey = Key(y);
	//̃L[ς̂ł̒lEɎgĂߓ_(t܂)̋ECB
	for( i = Right(z); i > 0; i = Left(i) )
		Minv(i) = zkey;
	for( i = Left(z); i > 0; i = Right(i) )
		Maxv(i) = zkey;
	x = Right(y);
	x_pst = &AssocTree(x);
	for( apoint = x_pst->firstPair(&inf); apoint >= 0; apoint = bpoint) {
		bpoint = x_pst->nextPair(&inf);
		jy = 0;
		for( iy = y; iy > 0; ) {
			if( iy != Left(Parent(iy)) ) break;
			iy = Parent(iy);
			ix = Right(iy);
			ix_pst = &AssocTree(ix);
			// 0:o^ 1:폜
			rc = ix_pst->deletion(apoint, points.a[apoint].y1, points.a[apoint].y2);
			if( rc != 1 ) break;
			if( ix_pst->root <= 0 )  psts.del_pst(&AsocT(ix));
			jy = iy;  //iỷEq炓폜łi݂jƂ̍Ōiyێ
		}
		if( jy > 0 ) {
			rc = x_pst->deletion(apoint, points.a[apoint].y1, points.a[apoint].y2);
			if( x_pst->root <= 0 ) { psts.del_pst(&AsocT(x)); CHKA(bpoint, bpoint, 0); }
			if( AsocT(jy) <= 0 )
				AsocT(jy) = psts.new_pst();
			jy_pst = &AssocTree(jy);
			rc = jy_pst->insert(apoint, points.a[apoint].y1, points.a[apoint].y2);
		}
	}
	return 0;
}

int RbTree::rb_delete(
	int z)
{
  int x, y; //RbtNode *x, *y;
  int rc, w;
//  if (Left(z) == Nil(T) || Right(z) == Nil(T)) { // z ̎q̐ 0  1
  if ( LeafNode(Left(z)) || LeafNode(Right(z)) ) { // z ̎q̐ 0  1
    y = z;
  } else { // z ̎q̐ 2
    y = rbtree_successor(z);
  }
  if (y != z) {
	  Key(z) = Key(y);
	  Usecnt(z) = Usecnt(y);
	  //̃L[ς̂ł̒lEɎgĂߓ_(t܂)̋ECB
	  case3_degree2(z, y);
  }
//  if (Left(y) != Nil(T)) x = Left(y); else x = Right(y);
  if ( ! LeafNode(Left(y)) ) {
	  x = Left(y);
	  w = Right(y);            //tm[h
  } else {
	  x = Right(y);
	  w = Left(y);            //tm[h
  }                     CHKA(1, x, NodeSize()); CHKA(1, w, NodeSize());
  Parent(x) = Parent(y);       //m[h؂؂藣
//  if (Parent(y) == Nil(T)) {
  if (Parent(y) == NilParent(T)) {
    Root(T) = x;
	psts.del_pst(&nodes.a[x].asocT); //ɂ͕t؂Ȃ
  } else {
	  if (y == Left(Parent(y))) {
        Left(Parent(y)) = x;
	  } else {
        Right(Parent(y)) = x;
    }
  }
  //Ԃ̏C
  Minv(x) = Minv(y);
  Maxv(x) = Maxv(y);
  if( ! isNilNode(Left(x))  ) Minv(Left(x))  = Minv(y);
  if( ! isNilNode(Right(x)) ) Maxv(Right(x)) = Maxv(y);
  //tW̏C
  rc = psts.plus(&AsocT(x), AsocT(y));         //ww{x
  if (Color(y) == BLACK) rb_delete_fixup(x); // ߓ_폜ꍇ͖؂C
//	if( y != Nil(T) ) this->free_node(y); //NT110527add
  if( LeafNode(y) )                   CHKA(0, y, -571);
  this->free_node(y);
  this->free_node(w);
  return y;
}

/*	ID_allocate_node	VKm[h쐬
*******************************************************************/
int RbTree::allocate_node( //R >=0:VK̃m[hԍ -4:̈mۂɎs      node[]or-4
	int y,                 //i em[hԍ 0:e                       node[]or0
	int x,                 //i qm[hԍ tm[ĥ͂                 node[]
	RbtData valp,          //i ǉf[^̋El
	int ucnt)              //i
{
	int z, w;
	RbtData valL, valR;
	                                    CHKA(1, x, NodeSize());
	if( y == NilParent(T) )             CHKB(0, nodes.a[x].asocT, 0); //m[hɃTu؂͖ʂȂ̂ōȂ
	//em[h̋ԂElŕAm[h̋Ԃݒ肷
#if 0
	if( y == NilParent(T) ) {
		valL = INT_MIN; valR = INT_MAX;
	} else if( valp < Key(y) ) {
		valL = nodes.a[y].minv; valR = nodes.a[y].key;
	} else if( valp > Key(y) ) {
		valL = nodes.a[y].key; valR = nodes.a[y].maxv;
	} else  CHKA(valp, Key(y), -571);
	CHKB(valL, Minv(x), valL);
	CHKB(valR, Maxv(x), valR);
#else
	valL = Minv(x);
	valR = Maxv(x);
#endif
	//VKԃm[h쐬
	z = nodes.ins(y, valp, ucnt, valL, valR);
	//VK̉Etm[h쐬
	w = nodes.ins(z, 0, 0, valp, valR);
	Color(w) = BLACK;         //tm[h͏ɍ
	Parent(w) = z;
	Right(z) = w;
	//m[htm[hɕύX
	nodes.a[x].maxv = valp;        CHKB(y, Parent(x), y);
	Parent(x) = z;
	Left(z) = x; // z ͗tȂ̂ōE̎q͖
	nodes.a[z].asocT = nodes.a[x].asocT;
//	nodes.a[x].asocT = psts.new_pst();
//	nodes.a[w].asocT = psts.new_pst();
	nodes.a[x].asocT = 0;
	nodes.a[w].asocT = 0;
	//em[h񂩂敪؂ɕKvȏݒ肷B
	return(z);
}

/*	ID_RbTree::free_node	m[h폜
*******************************************************************/
void RbTree::free_node(
	int x)
{	                                    CHKA(1, x, NodeSize());
	if( x > 0 ) {
		psts.del_pst(&nodes.a[x].asocT);
		nodes.del(x);
	}
}

// `FbN֐

void RbTree::print_tree(int x, int lv) //gp
{
//  if (x != Nil(T)) {
  if ( ! LeafNode(x) ) {
    print_tree(Right(x), lv+1);
	for( int i = 0; i < lv; ++i )
		printf("\t");
    printf("[%d,",Key(x));
    if (Color(x) == RED) printf("R] "); else printf("B] ");
	printf("\n");
    print_tree(Left(x), lv+1);
  }
}

/*	ID_RbTree::rb_check	tɎpX̍̐`FbN
*******************************************************************/
int RbTree::rb_check(int x) //m[htɎpX̍̐Ԃ
{
	int lh, rh, p;
	p = Parent(x);
	if( x == NilNode(T) ) { lh = 0; CHKA(0, x, -571); goto                  quit;}
	//t̐F͏ɍ̂͂Bm[hP̏ꍇ́Ať`m[ĥ݁B
	if ( LeafNode(x) ) {                    CHKB(0, Left(x), 0); CHKB(0, Right(x), 0);
		if( Color(x) == RED ) { CHKA(1, x, -571); //t͏ɍ ǂŔj󂵂Ă邩
			printf("rb_check: error RbtNode=Nil(T),R leaf color must be black.\n");
		}
		return 1; //PԂ
	}
	//tȊO͕KE̎qB݂̂ƂƂ͖
	CHKA(1, Left(x), NodeSize()); CHKA(1, Right(x), NodeSize());
	//̐F͏ɍ̂͂
	if( x == Root(T) ) {        CHKB(0, p, 0);
		if( Color(x) == RED ) { CHKA(2, x, -571); //add NT110527 root͏ɍ
			printf("rb_check: error RbtNode=%d,R root color must be black.\n",Key(x));
		}
	} else {                              CHKA(1, p, NodeSize());
		//eƂ̃L[l̑召̃`FbN
		int comp = (*this->compare)(Key(x), Key(p));
		if       ( x == Left (p) ) {    CHKA(comp, comp, 0);
		} else if( x == Right(p) ) {    CHKA(0, 0, comp);
		} else                          CHKA(p, x, -571);
		//eԐߓ_Ȃq͍
		if (Color(p) == RED) {
			if (Color(x) != BLACK) {  CHKA(3, x, -571); 
				printf("rb_check: error parent and child color are RED parent=%d,R child=%d,R\n",Key(p), Key(x));
			}
		}
	}
	//tɎpX̍m[h͓͂B
	lh = rb_check(Left(x)); // ؂̍
	rh = rb_check(Right(x)); // E؂̍
	if (lh != rh) { CHKA(5, x, -571);  // E̍vĂȂ΃G[
		printf("rb_check: error RbtNode=%d lh=%d rh=%d\n", Key(x), lh, rh);
	}
	//m[h̐FȂ獕ɂPZ
	if (Color(x) == BLACK) lh++;
quit:
	return lh;		//̐Ԃ
}
