/*
 * FILE     : segtree_1.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : g敪(augmented segment tree)
 * AUTHER   : N.Tsuchiya  2011.05.06
 */
//static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
static char *__file =__FILE__;     /* should be copied into all .c files   */

#include "segtree.h"

/*  ID_rb_comp	r֐
***************************************************************************/
int rb_comp(int key1,int key2)
{
//	return key1 - key2;
	int rc;
	if     ( key1 < key2 ) rc = -1;
	else if( key1 > key2 ) rc = 1;
	else                   rc = 0;
	return rc;
}
/*  ID_SegPoints::clear	|Cg̏WNA
***************************************************************************/
int SegPoints::clear()
{
	this->num = 0;
	this->a.clear();
	return 0;
}
/*  ID_SegPoints::ins	|CgWɒǉ
***************************************************************************/
int SegPoints::ins(    //r >=0:|Cgz̓YB-1:G[
	int no,         //i |CgԍBOȏ
	int *xi)        //i |Cgdim̍Wl x1,x2,y1,y2
{
	int rc;
	SegPoint wp;

	//zg
	while( no >= this->a.size() ) {
		try{ this->a.push_back(wp); }catch(...){ rc = -1; goto          quit;}
	}
	if( this->a[no].usef == 0 ) { ++this->num; //NT110413 add goto quit
	} else { rc = -1; CHKB(1, this->a[no].usef, 0); goto                quit; //gp
	}
	wp.usef = 1;
	wp.x1 = xi[0]; wp.x2 = xi[1];  CHKB(wp.x1, wp.x1, wp.x2);
	wp.y1 = xi[2]; wp.y2 = xi[3];  CHKB(wp.y1, wp.y1, wp.y2);
	this->a[no] = wp;
	rc = no;
quit:
	return rc;
}
/*  ID_SegPoints::del	|CgW폜
***************************************************************************/
int SegPoints::del(    //r 0:, -1:G[
	int idx)        //i |Cgz̓YBOȏ
{
	int rc = -1;						
	if( idx < 0 || idx >= this->a.size() ) goto          quit;
	if( this->a[idx].usef != 0 ) --this->num;
	else                                CHKB(1, this->a[idx].usef, 1);
	this->a[idx].usef = 0;
	rc = 0;
quit:
	return rc;
}
/*  ID_Nodes::clear	ߓ_̏WNA
***************************************************************************/
int SegNodes::clear()
{
	this->num = 0;
	this->topEmpty = 0;
	this->a.clear();
	this->a.push_back(SegNode());   //node[0]͎gȂ
	return 0;
}
/*  ID_Nodes::ins	ߓ_Wɒǉ
***************************************************************************/
int SegNodes::ins(    //r >0:ߓ_z̓YB-1:G[
	int poya,
	int keyval,
	int ucnt,
	int minval,
	int maxval)
{
	SegNode wnod(keyval, ucnt, minval, maxval);
	int rc = 0;
	                                    CHKB(minval, minval, maxval); //CHKA(0, oya, this->a.size());
//	wnod.left  = 0;
//	wnod.right = 0;
//	wnod.key   = keyval;
//	wnod.minv  = minval;                CHKB(minval, minval, maxval);
//	wnod.maxv  = maxval;
	if( this->topEmpty > 0 ) {
		rc = this->topEmpty;            CHKB(-1, this->a[rc].left, -1);
		this->topEmpty =  this->a[rc].right;
		this->a[rc] = wnod;
	} else {
		rc = this->a.size();
		this->a.push_back(wnod);
	}
	++this->num;                         CHKB(1, rc, this->a.size());
	return rc;
}
/*  ID_Nodes::del	ߓ_W폜
***************************************************************************/
int SegNodes::del(
	int idx)        //i ߓ_z̓YBOȏ
{
	int rc = -1;
									    CHKA(1, idx, this->a.size());
	if( idx < 1 || idx >= this->a.size() ) goto                    quit;
	                                    CHKA(0, this->a[idx].left, this->a.size());
	this->a[idx].right = this->topEmpty; CHKA(0, this->topEmpty, this->a.size());
	this->a[idx].left  = -1;
	this->topEmpty = idx;
	--this->num;
	rc = 0;
quit:
	return rc;
}
/*  ID_Nodes::get	ߓ_擾B
***************************************************************************/
SegNode& SegNodes::get(   //r ߓ_B
	int idx)        //i ߓ_z̓YBOȏ
{
									CHKA(0, idx, this->a.size());
	return(this->a[idx]);
}

/*  ID_SegTree::SegTree	敪؂̃RXgN^
***************************************************************************/
SegTree::SegTree() : nil(0), compare(rb_comp) //RXgN^
{
	//rc = allocate_node(psts, oya, valp)͌ĂׂȂ̂œeRs[BύX͗v
	//tm[h琬鏉敪؂B
	root = nodes.ins(0, 0, 0, INT_MIN, INT_MAX);
	nodes.a[root].color = BLACK;
}
/*  ID_DrTrees::clear	g敪؂čėp\ɂ
***************************************************************************/
int SegTree::clear()
{
	this->psts.clear(); //NT120405
	this->nodes.clear();
	this->points.clear();
//	this->root = 0;
	//rc = allocate_node(psts, oya, valp)͌ĂׂȂ̂œeRs[BύX͗v
	//tm[h琬鏉敪؂B
	root = nodes.ins(0, 0, 0, INT_MIN, INT_MAX);
	nodes.a[root].color = BLACK;
	return 0;
}
/*  ID_DrTrees::point_ins	P̓__WɒǉBcreate()ĂŊg敪؂ꊇ\
[x,x]͓o^łȂ
***************************************************************************/
int SegTree::point_ins(    //rc>0:,|Cgz̓YB=-1:G[
	int poNo,       //i |CgԍBOȏBpoNôQd`͕sB
	int *xi)        //i |Cgdim̍WlBx1,x2,y1,y2
{
	int rc;
	if( xi[0] == xi[1] ) {
		rc = -1; CHKA(0, xi[0], xi[1]);
	} else {
		rc = points.ins(poNo, xi);
	}
	return rc;
}
