/*
 * FILE     : segtree_2.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : g敪(augmented segment tree)
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include <limits.h>
#include "segtree.h"
#include "xqsort.h"

/*  ID_SegTree::segt_insdel	敪؂ɐo^/
***************************************************************************/
int SegTree::segt_insdel( //R o^/ 0: 1:s
	int anode,    //i ߓ_ԍBŏ͍ߓ_ŌďoB           nodes.a[]
	int apoint,   //i |CgBPSTreeɓo^邽߂ɎgB points.a[]
	int low,      //i ̍W
	int high,     //i ̉EW
	int insdel,   //i 1:o^ 2: 3:݃`FbN 4:pairǉ̂
	int *actFlag) //o 1:o^/
{
	int actL, actR, rc;
	SegNode *vnode = &nodes.a[anode];

	actL = actR = *actFlag = 0;
	if( anode <= 0 ) { CHKA(apoint, high, low);//o^/sB̒[_o^
	} else if( low <= vnode->minv && vnode->maxv <= high ) {  //[Ă݂BdrtŒׂĂ͂ NT110515
		//m[hanode̋ԂɊ܂܂ȂAm[hɓo^/ďIB
		if( insdel == 1 ) {
			if( vnode->asocT <= 0 )
				vnode->asocT = psts.new_pst();
			psts.ary[vnode->asocT].insert(apoint, points.a[apoint].y1, points.a[apoint].y2 );
		} else if( insdel == 2 ) {
			if( vnode->asocT > 0 ) { //ifsv
				psts.ary[vnode->asocT].deletion(apoint, points.a[apoint].y1, points.a[apoint].y2 );
				if( psts.ary[vnode->asocT].root <= 0 ) psts.del_pst(&vnode->asocT);
			}
		} else if( insdel == 3 ) {
			rc = psts.ary[vnode->asocT].find(apoint, points.a[apoint].y1, points.a[apoint].y2 ); CHKB(1, rc, 1);
		} else if( insdel == 4 ) {      //create()ł̂ݎgp
//			PSTree::BPSTpair wkPair(apoint, points.a[apoint].y1, points.a[apoint].y2);
//			rc = psts.ary[vnode->asocT].pair_add(wkPair);
			ulist.push_back(apoint);     //point[]Y
			usecnt.push_back(vnode->topPair);    //m[hpairB擪nodes.a[].topPair    ulist[]Y
			vnode->topPair = usecnt.size() - 1;
		} else                          CHKB(1, insdel, 4);
		*actFlag = 1;
	} else {
		if( low  < vnode->key ) { segt_insdel(vnode->left , apoint, low, high, insdel, &actL); CHKB(1, actL, 1); }
		if( high > vnode->key ) { segt_insdel(vnode->right, apoint, low, high, insdel, &actR); CHKB(1, actR, 1); }
	}
	if( *actFlag || actL || actR ) vnode->segt_act = *actFlag = 1;
//	CHKB(1, *actFlag, 1); //[̂ NT110515
	return (*actFlag == 0);
}
/*  ID_SegTree::segt_insert	敪؂ɐo^
***************************************************************************/
int SegTree::segt_insert( //R o^ 0: 1:s
	int anode,    //i ߓ_ԍBŏ͍ߓ_ŌďoB           nodes.a[]
	int apoint,   //i |CgBPSTreeɓo^邽߂ɎgB points.a[]
	int low,      //i ̍W
	int high,     //i ̉EW
	int insdel,   //i 1:o^ 4:pairǉ̂ i2: 3:݃`FbNj
	int *actFlag) //o 1:ǉ
{
	return segt_insdel(anode, apoint, low, high, insdel, actFlag);
}
/*  ID_SegTree::segt_delete	敪؂𖕏
***************************************************************************/
int SegTree::segt_delete( //R  0: 1:s
	int anode,  //i ߓ_ԍBŏ͍ߓ_ŌďoB           nodes.a[]
	int apoint, //i |CgBPSTreeɓo^邽߂ɎgB points.a[]
	int low,    //i ̍W
	int high,   //i ̉EW
	int *actFlag) //o 1:ǉ
{
	return segt_insdel(anode, apoint, low, high, 2, actFlag);
}
/*  ID_SegTree::BuildSegTree	敪؂\B
***************************************************************************/
int SegTree::BuildSegTree( //r SegNodes[]YԂ
	int nPlist,     //i Plist̃|CgBO
	int *Plist,     //i \[gς݂̂wWl̔z
	int *usecnt,    //i wWl[_Ɏ̔z
	int poya,       //i em[hBOFe                 node[]or0
	int rootf,      //i 1: 0:/t B؂̍ɂ͓؂Ȃ
	int xrangeL, //i WMin,Max root̂ƂINT_MIN,INT_MAX
	int xrangeR, //i WMin,Max root̂ƂINT_MIN,INT_MAX
	int bh)          //i m[h̍
{
	int p, vleft, vright, anode, numL, numR;
	int xkey;

	if( nPlist <= 0 ) {   //CHKB(1, 1, nPlist);
		//@ if P P_̂then
		//̓_i[tv C؂̒Pm[h̖؂ƂĈv ̓Tassoc ƂD
		//ŗtm[h쐬 TODO eƔ͈͈͂
		xkey = 0; //tm[hɂ̓L[
		anode = nodes.ins( 0, xkey, 0, xrangeL, xrangeR);
//		nodes.a[anode].asocT = psts.new_pst();
		nodes.a[anode].asocT = 0;
		nodes.a[anode].color = BLACK;
	} else {
		//B P x W̒Ԓl_p Pleft Pright ɂQC
		p = nPlist / 2;
		numL = p;
		numR = nPlist - numL - 1;
		xkey = Plist[p] ;
		anode = nodes.ins(0, xkey, usecnt[p], xrangeL, xrangeR);
//		nodes.a[anode].asocT = psts.new_pst();
		nodes.a[anode].asocT = 0;
		nodes.a[anode].color = ( bh == 0 ) ? RED : BLACK;
		//C vleft ? BuildSegTree(Pleft)
		vleft = BuildSegTree(numL, Plist, usecnt, anode, 0, xrangeL, xkey, bh - 1 );
		//D vright ? BuildSegTree(Pright)
		vright = BuildSegTree(numR, Plist + p + 1, usecnt + p + 1, anode, 0, xkey, xrangeR, bh - 1 ); //add + 1 NT110519
		//E p ɑΉm[hv Clc(v)  vleft, rc(v)  vright ƂĎ؂
		nodes.a[anode].left  = vleft;
		nodes.a[anode].right = vright;
		nodes.a[vleft].oya   = anode;
		nodes.a[vright].oya  = anode;
		//F Tassoc(lc(v) Tassoc(rc(v) }[W, v ǉTassoc(v) 
//		//؂̍ɂ͓؂Ȃ
//		nodes.a[anode].assoc = (rootf) ? 0 : mearge(level + 1, anode, nPlist, Plist);
	}
	//G v Ԃ
	//^ꂽʂ̓_WP ƂBuildSegTree(P) Ăׂ΁C
	//Q敪T (؂Ɠؓ) 珇ɍċAIɍ\C
	//̃[gm[hւ̃|C^ԂD
	return anode;
}
/*  ID_compInt	|CgrBiqsort()pAP̂݁j
***************************************************************************/
int SegTree::compInt(
	const int *p, const int *q) //wWl
{
	int rc;
	if     ( xlist[*p] < xlist[*q] ) rc = -1;
	else if( xlist[*p] > xlist[*q] ) rc = 1;
	else                             rc = *p - *q;
	return rc;
}
/*  ID_SegTree::genPst	PSTꊇ\B
***************************************************************************/
int SegTree::genPst(
	int anode,  //i ߓ_ԍBŏ͍ߓ_ŌďoB           nodes.a[]
	VECTOR<int> &sortwk)
{
	int rc, k, apair, apoint;
	SegNode *vnode;
#if 0 //ċA
	if( anode > 0 ) {
		vnode = &nodes.a[anode];
		if( (rc = psts.ary[vnode->asocT].build()) < 0 ) goto            quit;
		if( (rc = genPst(vnode->left , sortwk)) < 0 ) goto              quit;
		if( (rc = genPst(vnode->right, sortwk)) < 0 ) goto              quit;
	}
#else //ċA
	int n_swk = 0;
	sortwk.resize(nodes.a.size());
	sortwk[n_swk++] = 0; //X^bN{g
	for( ; anode > 0; anode = sortwk[--n_swk] ) {
		vnode = &nodes.a[anode];
		if( vnode->left  > 0 ) sortwk[n_swk++] = vnode->left;
		if( vnode->right > 0 ) sortwk[n_swk++] = vnode->right;
		if( vnode->topPair > 0 ) {      CHKB(0, vnode->asocT, 0);
			if( vnode->asocT <= 0 )  //ifsv
				vnode->asocT = psts.new_pst();
			xsortwk.clear();
			for( k = vnode->topPair; k > 0 ; k = usecnt[k] ) {
				apoint = ulist[k];
				PSTree::BPSTpair wkPair(apoint, points.a[apoint].y1, points.a[apoint].y2);
				apair = psts.ary[vnode->asocT].pair_add(wkPair);
				xsortwk.push_back(apair);
			}
			if( (rc = psts.ary[vnode->asocT].build(xsortwk)) < 0 ) goto        quit;
		}
	}
#endif
	rc = 0;
quit:
	return rc;
}
/*  ID_SegTree::create	敪؂ꊇ\B
***************************************************************************/
int SegTree::create()
{
	int rc = 0, i, n_endPoi, actFlag, bh, cnt1;
	//敪؂
	//_WP BnI_WŃ\[gAj[N
	xlist.resize(2 * points.a.size()); //\[gp[N
	ulist.resize(2 * points.a.size()); //\[gp[N
	xsortwk.resize(2 * points.a.size()); //\[gp[N
	usecnt.resize(2 * points.a.size()); //usecntp[N
	cnt1 = 0;
	for( i = 0; i < points.a.size(); ++i ) {
		if( points.a[i].usef == 0 ) continue;
		xlist[cnt1++] = points.a[i].x1;
		xlist[cnt1++] = points.a[i].x2;
	}                                   //CHKB(cnt1, sortwk.size(), cnt1);
	for( i = 0; i < cnt1; ++i )
		xsortwk[i] = i;
	if( cnt1 <= 0 ) goto                                       quit;
	                                    CHKB(1, nodes.num, 1);
	this->nodes.clear(); //Ԃł[-,]̗tandߓ_폜 NT120511
//	qsort(&sortwk[0], sortwk.size(), sizeof(sortwk[0]), QSORT_TYP compInt);
	xqsort(&xsortwk[0], cnt1, *this, &SegTree::compInt);
	//̒[_Wj[Nɂ
	n_endPoi = -1;
	for( i = 0; i < cnt1; ++i ) {
		if( i > 0 && ulist.v[n_endPoi] == xlist.v[xsortwk.v[i]]) {
			usecnt[n_endPoi] += 1;
		} else {
			n_endPoi++;
			ulist[n_endPoi] = xlist.v[xsortwk.v[i]];
			usecnt[n_endPoi] = 1;
		}
	}
	++n_endPoi;
	//tpX̍m[h̐Bn=[7-14]bh=4An+1̍ŏʃrbgʒu
	i = n_endPoi + 1;
	for( bh = -1; i != 0; ++bh )
		i = i >> 1;
	//敪؂\B
	root = BuildSegTree(n_endPoi, &ulist[0], &usecnt[0], 0, 1, INT_MIN, INT_MAX, bh );
	nodes.a[root].oya  = 0; //NT110819add
	//ԍ؂̃`FbN        NT110819
	if( dbgf[8]) rb_check(root);
	//ł́Axlist,xsortwk,ulist,usecnt͗pς݂ɂȂĂB
	ulist.clear();  ulist.push_back(0);   //pair[]Y
	usecnt.clear(); usecnt.push_back(0);   //m[hpairB擪nodes.a[].topPair    ulist[]Y
	//`o^
	for( i = 0; i < points.a.size(); ++i ) {
		if( points.a[i].usef == 0 ) continue;
		if( dbgf[8]) CHKA(points.a[i].x1, points.a[i].x1, points.a[i].x2);
		//敪(Segment Tree)ɐo^(PST͂܂Ȃ)
		segt_insert(root, i, points.a[i].x1, points.a[i].x2, 4, &actFlag ); CHKB(1, actFlag, 1);
	}
	//PSTꊇ\B
	rc = genPst(root, xlist);
quit:
	//敪؂̃`FbN
	if( dbgf[8]) this->tree_check1( this->root, 0, INT_MIN, INT_MAX );
	return rc;
}
	//
/*  ID_SegTree::dst_ins	`(x1,x2,y1,y2)𓮓Iɓo^B
***************************************************************************/
int SegTree::dst_ins( //0: <0:G[
	int poNo,       //i |CgԍBOȏBpoNôQd`͕sB
	int *xi)        //i |Cgdim̍WlBx1,x2,y1,y2
{
	int rc, i, actFlag;
	if( xi[0] == xi[1] ) { rc = -1; CHKA(0, xi[0], xi[1]); goto quit; }
	//敪؂ɍ[_o^
	rc = this->add( xi[0] );
	//敪؂ɉE[_o^
	rc = this->add( xi[1] );
	//敪(Segment Tree)ɐo^
//	i = rc = this->point_ins(poNo, xi);
	i = rc = points.ins(poNo, xi);
	if( dbgf[8]) CHKA(points.a[i].x1, points.a[i].x1, points.a[i].x2);
	segt_insert( root, i, points.a[i].x1, points.a[i].x2, 1, &actFlag ); CHKB(1, actFlag, 1);
	//敪؂̃`FbN
//this->dump_nod(psts); 
if( dbgf[8]) this->tree_check1( this->root, 0, INT_MIN, INT_MAX );
	rc = 0;
quit:
	return rc;
}
/*  ID_SegTree::dst_del	`폜B
***************************************************************************/
int SegTree::dst_del( //0: <0:poNo[_o^Ȃ
	int poNo,       //i |CgԍBOȏBpoNôQd`͕sB
	int *xi)        //i |Cgdim̍WlBx1,x2,y1,y2
{
	int rc, i, actFlag;
	//敪(Segment Tree)𖕏
	if( (i = rc = points.find(poNo, xi)) < 0 ) goto quit;
	segt_delete( root, i, points.a[i].x1, points.a[i].x2, &actFlag ); CHKB(1, actFlag, 1);
	if( (rc = points.del(i)) < 0 ) goto                                 quit;
	//敪؂E[_폜
	if( (rc = this->del( xi[1] )) < 0 ) goto                            quit;
//if( dbgf[8]) this->tree_check1( this->root, 0, INT_MIN, INT_MAX );
	//敪؂獶[_폜
	if( (rc = this->del( xi[0] )) < 0 ) goto                            quit;
//this->dump_nod(psts); 
if( dbgf[8]) this->tree_check1( this->root, 0, INT_MIN, INT_MAX );
	rc = 0;
quit:
	return rc;
}
/*  ID_SegTree::dst_check	`(x1,x2,y1,y2)o^Ă邩`FbNB
***************************************************************************/
int SegTree::dst_check(
	int poNo,       //i |CgԍBOȏBpoNôQd`͕sB
	int *xi)        //i |Cgdim̍WlBx1,x2,y1,y2
{
	int rc, i, actFlag;
	//敪(Segment Tree)
	i = rc = points.find(poNo, xi);
	if( i >= 0 ) {
		rc = segt_insdel( root, i, points.a[i].x1, points.a[i].x2, 3, &actFlag );
	}
	return rc;
}