/*
 * FILE     : segtree_check.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : g敪(augmented segment tree)
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include "segtree.h"

/*  ID_SegTree::check_ans	query̓̃`FbN
***************************************************************************/
int SegTree::check_ans(
	int lrOpen,      //i JԎw 1: 2:E 3: J 0:
	int *xyy)
{
	int i, apoin, n_point;

//	xlist points.a.size()made 0clear, ans [] 1
	n_point = points.a.size();
	xlist.resize(n_point);
	for( apoin = 0; apoin < n_point; ++apoin ) xlist[apoin] = 0;
	for( i = 0; i < ans.size(); ++i ) {
		apoin = ans[i];					CHKB(0, xlist[apoin], 0);
		xlist[apoin] = 1;
	}
	for( apoin = 0; apoin < n_point; ++apoin ) {
		SegPoint &p = points.a[apoin];
		if( points.a[apoin].usef == 0 ) continue;
		                                CHKB(1, points.a[apoin].usef, 1);
		i = SegCoord::isCross(lrOpen, p, xyy);
		if( xyy[0] == p.x1 && (lrOpen & 1) ) i = 0; //J̏ꍇ
		if( xyy[0] == p.x2 && (lrOpen & 2) ) i = 0; //J̏ꍇ
//		if( ans.exist(apoin) ) {}
		if( xlist[apoin] ) {
			CHKB(1, i, 1);
		} else {
			CHKB(0, i, 0); //o
			if( i != 0 ) {
				Dprintf("check_ans [%d] Q(%d)(%d,%d) P(%d,%d)(%d,%d)\n", apoin, xyy[0], xyy[1], xyy[2], p.x1, p.x2, p.y1, p.y2);
			}
		}
	}
	return 0;
}
/*  ID_SegTree::tree_check1	treẽW`FbN
***************************************************************************/
int SegTree::tree_check1(
	int anod,           //i Ώۃm[h     (>0)
	int oynod,          //i anod ̐em[h(=0 )
	int xrangeL, //WMin,Max root̂ƂINT_MIN,INT_MAX
	int xrangeR) //WMin,Max root̂ƂINT_MIN,INT_MAX
{
	SegNode	*wnod, *wnod2;
	SegPoint	*wpnt;
	int apoint, inf, oyminv, oymaxv;					CHKA(0, anod, nodes.a.size());
	
	if( anod <= 0 ) goto                                              quit;
	//݂̂̃`FbN
	if( oynod <= 0 ) { //nodes.a[0]͖gp̂͂
		wnod = &nodes.a[0]; CHKB(0, wnod->left, 0); CHKB(0, wnod->right, 0); CHKB(0, wnod->oya, 0); CHKB(0, wnod->asocT, 0);
	}
	//
	wnod = &nodes.get(anod);    CHKB(oynod, wnod->oya, oynod);  //e|C^`FbN
	//m[h̋Ԃ̃`FbN
	if( wnod->minv != xrangeL ) CHKB(xrangeL, wnod->minv, xrangeL);
	if( wnod->maxv != xrangeR ) CHKB(xrangeR, wnod->maxv, xrangeR);
	                            CHKA(wnod->minv, wnod->minv, wnod->maxv);
	//ԃm[h͍E̎qBxrangeLwnod->keyxrangeR̂͂B
	if( wnod->left > 0 ) { CHKA(1, wnod->right, nodes.a.size());  //qΉEq͂
		CHKB(1, 1, wnod->usecnt);  //ԃm[h̃L[l[_ɎPȏ゠͂
		if( wnod->key >= xrangeR ) CHKA(wnod->key, wnod->key, xrangeR); //L[l̓m[h̋Ԃ̓̂͂
	    if( wnod->key <= xrangeL ) CHKA(xrangeL, xrangeL, wnod->key);
		if( oynod > 0 ) {
			wnod2 = &nodes.get( oynod );
			if       ( wnod2->left  == anod ) { CHKA(wnod->key, wnod->key, wnod2->key); //
			} else if( wnod2->right == anod ) { CHKA(wnod2->key, wnod2->key, wnod->key); //E
			} else  CHKB(4, 0, -571); //em[h̎qɂȂĂȂ
		}
	//tm[hFkey͎gȂBE̎q
	} else {               CHKB(0,wnod->right, 0); CHKB(0,wnod->left, 0);
	}
	if( wnod->asocT != 0 ) {
		oyminv = nodes.a[oynod].minv;
		oymaxv = nodes.a[oynod].maxv;
		PSTreeAsoc &asoct = psts.ary[wnod->asocT];
		//t܂ނׂẴm[hɒ~ꂽ͈̔͂́AYm[h͈̔͂܂ł͂B
		for( apoint = asoct.firstPair(&inf); apoint >= 0; apoint = asoct.nextPair(&inf) ) {
			wpnt = &points.a[apoint];
			//m[hpoint͎m[h̋Ԃ܂ނ͂
			if( wpnt->x1 > wnod->minv ) CHKB(wpnt->x1, wpnt->x1, wnod->minv);
			if( wnod->maxv > wpnt->x2 ) CHKB(wnod->maxv, wnod->maxv, wpnt->x2);
			//m[hpoint͐em[h̋Ԃ܂܂Ȃ͂
			if( oynod > 0 ) {
				if( wpnt->x1 <= oyminv && oymaxv <= wpnt->x2 ) CHKB(oynod, anod, -571);
			}
		}
	}
	//m[hEm[hꂼ`FbN
	tree_check1( wnod->left , anod, xrangeL, wnod->key );
	tree_check1( wnod->right, anod, wnod->key, xrangeR );
quit:
	return 0;
}
void SegTree::dump_nod(
	PSTrees &psts)
{
	int i, k, inf;
	PSTreeAsoc *pst;
	char *col;
	SegPoint	*wpnt;

	Dprintf("root(%d) this->nodes.a.size()(%d)\n", this->root, this->nodes.a.size());
	for( i = 0; i < this->nodes.a.size(); ++i ) {
		SegNode &nd = this->nodes.a[i];
		if( nd.left < 0 ) continue;
		col = (nd.color == RED) ? "R" : "B";
		SegNode &noya = this->nodes.a[nd.oya];
		Dprintf("%2d)key(%4d)oya(%3d,%d,%d)left(%3d)right(%3d)col(%s)usecnt(%d) minv(%3d) maxv(%3d) asocT(%3d) segt_pst"
		, i, nd.key, nd.oya, noya.minv, noya.maxv, nd.left, nd.right, col, nd.usecnt, nd.minv, nd.maxv, nd.asocT); //, nd.type);
		pst = &psts.ary[nd.asocT];
		for( k = pst->firstPair(&inf); k >= 0; k = pst->nextPair(&inf) ) {
			wpnt = &points.a[k];
			Dprintf(" (%2d:%d,%d)", k, wpnt->x1, wpnt->x2);
	}
		Dprintf("\n");
	}
	return;
}

